#include "dialog.h"
#include "ui_dialog.h"
#include <QMessageBox>

Dialog::Dialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dialog)
{
    ui->setupUi(this);
    state = 0;  // Startzustand
}

Dialog::~Dialog()
{
    delete ui;
}

void Dialog::on_button_a_clicked()
{
    aktion('a');
}

void Dialog::on_button_b_clicked()
{
    aktion('b');
}

void Dialog::on_button_c_clicked()
{
    aktion('c');
}

void Dialog::aktion(char taste)
{
    // Zustandsautomat für Codeschloss
    switch(state)
    {
    case 0:
        if(taste == 'a') state = 1;
        break;

    case 1:
        if(taste == 'b') state = 2;
        else if(taste == 'a') state = 1;
        else state = 0;
        break;

    case 2:
        if(taste == 'c') state = 3;
        else if(taste == 'a') state = 1;
        else state = 0;
        break;

    case 3:
        if(taste == 'b') state = 4;
        else if(taste == 'a') state = 1;
        else state = 0;
        break;

    case 4:
        if(taste == 'a')
        {
            QMessageBox msgBox;
            msgBox.setText("Schloss ist offen!");
            msgBox.exec();
        }
        state = 0;
        break;
    }
}
